﻿using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Collections.Generic;
using System.IO;
using Npgsql;

namespace ClienteDeEscritorioFotos
{
  public partial class Eliminar : Form
  {
    public Eliminar()
    {
      InitializeComponent();
      lbFotos.DisplayMember = "Key"; // propiedad para mostrar por la lista
      lbFotos.ValueMember = "Value"; // propiedad para el valor del elemento de la lista

      CargarDatos(); // cargar los datos en la lista
    }

    private void CargarDatos()
    {
      // Limpiar la lista
      lbFotos.Items.Clear();
      // Conexión
      NpgsqlConnection Conexion = new NpgsqlConnection(Mostrar.sConexion);
      // Orden SQL
      string sOrdenSQL = "select nombre, foto from album";
      NpgsqlCommand OrdenSQL = new NpgsqlCommand(sOrdenSQL, Conexion);
      // Abrir la conexión con la BD y ejecutar la orden SQL
      Conexion.Open();
      NpgsqlDataReader Lector = OrdenSQL.ExecuteReader();
      if (Lector != null)
      {
        while (Lector.Read())
        {
          lbFotos.Items.Add(new KeyValuePair<string, string>(
            Lector.GetString(0), Lector.GetString(1)));
        }
      }
      Conexion.Close();
    }

    protected void btBorrar_Click(object sender, EventArgs e)
    {
      if (this.lbFotos.SelectedIndex != -1)
      {
        
        // Ruta de la foto
        string sFoto = ((KeyValuePair<string, string>)
                        this.lbFotos.SelectedItem).Value;
        // Invocar EliminarFoto al método del servicio Web
				rServWebFotos.ServWebFotos servicio =
          new rServWebFotos.ServWebFotos();
        // Borrar el fichero que almacena la foto, el registro
        // de la base de datos y la entrada de la lista
        try
        {
          servicio.EliminarFoto(sFoto);
          lbFotos.Items.Remove(lbFotos.SelectedItem);
          this.Close();
        }
        catch
        {
          MessageBox.Show(this, "Error al borrar la foto: " + 
            sFoto, "Borrar foto",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
      }
    }
  }
}
