// ServWebFotos.asmx.cs created with MonoDevelop
// User: Ceballos
//

using System;
using System.Web;
using System.Web.Services;
using Npgsql;
using System.Data;
using System.Configuration;
using System.IO;

namespace ServicioWebFotos
{
	public class ServWebFotos : System.Web.Services.WebService
	{
    const string sCarpFotos = "fotos";
    private string sConexion;
    private NpgsqlConnection ConexionBdFotos;
    
    public ServWebFotos()
    {
      // Cadena de conexión (véase Web.Config)
      sConexion = ConfigurationManager.ConnectionStrings["cc_fotos"].ConnectionString;
      // Conexión
      ConexionBdFotos = new NpgsqlConnection(sConexion);
    }

    [WebMethod(Description =
     "Añadir una foto a la BD fotos y copiar el array de bytes " +
     "en la carpeta fotos como una imagen")]
    public void AgregarFoto(string nomFich, string nombre,
	                          string autor, string descripcion,
                            byte[] img)

    {
      // Ruta de la carpeta "fotos" en el sitio web
      string sRutaFotos = Server.MapPath(sCarpFotos);
      FileStream fNuevaFoto = null;
			try
      {
  			if (!Directory.Exists(sRutaFotos))
  			{
  				Directory.CreateDirectory(sRutaFotos);
        }			

  		  if (!sRutaFotos.EndsWith(Path.DirectorySeparatorChar.ToString()))
  			  sRutaFotos += Path.DirectorySeparatorChar.ToString();
  		    
  		  fNuevaFoto = File.Create(sRutaFotos + nomFich);
   			fNuevaFoto.Write(img, 0, img.Length);
  		}
  		finally
  		{
  			if (fNuevaFoto != null) fNuevaFoto.Close();
  		}
      
      string sOrdenSQL =
        "insert into album (foto, nombre, autor, descripcion) " +
        "values (:foto,:nombre,:autor,:descripcion)";

      NpgsqlCommand OrdenSQL = new NpgsqlCommand(sOrdenSQL, ConexionBdFotos);

      OrdenSQL.Parameters.Add(new NpgsqlParameter("foto",
        NpgsqlTypes.NpgsqlDbType.Varchar, 30));
      OrdenSQL.Parameters["foto"].Value = sCarpFotos +
        System.IO.Path.DirectorySeparatorChar.ToString() + nomFich;

      OrdenSQL.Parameters.Add(new NpgsqlParameter("nombre",
        NpgsqlTypes.NpgsqlDbType.Varchar, 30));
      OrdenSQL.Parameters["nombre"].Value = nombre;

      OrdenSQL.Parameters.Add(new NpgsqlParameter("autor",
        NpgsqlTypes.NpgsqlDbType.Varchar, 30));
      OrdenSQL.Parameters["autor"].Value = autor;

      OrdenSQL.Parameters.Add(new NpgsqlParameter("descripcion",
        NpgsqlTypes.NpgsqlDbType.Varchar, 400));
      OrdenSQL.Parameters["descripcion"].Value = descripcion;

      OrdenSQL.Connection.Open();
      OrdenSQL.ExecuteNonQuery();
      OrdenSQL.Connection.Close();
    }

    [WebMethod(Description =
     "Eliminar una foto de la BD fotos y eliminar la imagen " +
     "de la carpeta fotos")]
    public void EliminarFoto(string fotoSeleccionada)
    {
      string sOrdenSQL = "delete from album where foto = :foto";

      NpgsqlCommand OrdenSQL = new NpgsqlCommand(sOrdenSQL, ConexionBdFotos);
      OrdenSQL.Parameters.Add(new NpgsqlParameter("foto",
        NpgsqlTypes.NpgsqlDbType.Varchar, 30));
      OrdenSQL.Parameters["foto"].Value = fotoSeleccionada;

      OrdenSQL.Connection.Open();
      OrdenSQL.ExecuteNonQuery();
      OrdenSQL.Connection.Close();
      
			string sRutaSitioWeb = Server.MapPath("/");
			
			if (!sRutaSitioWeb.EndsWith(Path.DirectorySeparatorChar.ToString()))
				sRutaSitioWeb += Path.DirectorySeparatorChar.ToString();
			
			if(File.Exists(sRutaSitioWeb + fotoSeleccionada))
				File.Delete(sRutaSitioWeb + fotoSeleccionada);
    }
  }
}
