using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

namespace ClienteDeEscritorioFotos
{
  public partial class Mostrar : Form
  {
    private int _iActual = -1; // ndice de la foto mostrada

    public Mostrar()
    {
      InitializeComponent();
    }

    private void Mostrar_Load(object sender, EventArgs e)
    {
      RecuperarBD();
      ActualizarFoto();
    }

    private void RecuperarBD()
    {
      // Recuperar las fotos de la base de datos y almacenarlas
      // en un conjunto de datos

      // Actualizar el ndice de la foto si hubiera sido afectado
      // por la operacin eliminar foto.

      // Supongamos que hay una foto:
      _iActual = 0;
    }

    private void ActualizarFoto()
    {
      // Mostrar la foto especificada por _iActual
      // y la informacin sobre la misma
      string sUrl = ObtenerUrlServicioWeb();

      if (_iActual == -1)
      {
        this.ciFoto.Image = null;
        this.ctNombre.Text = string.Empty;
        this.ctAutor.Text = string.Empty;
        this.ctDescripcion.Text = string.Empty;
      }
      else
      {
        string rutaFoto = "imagenes/yo.png";
        this.ciFoto.Image = Image.FromStream(new System.Net.WebClient().OpenRead(sUrl + rutaFoto));
        //this.ciFoto.Image = Image.FromFile(RutaFotos + );

        this.ctNombre.Text = "Profesor Ceballos";
        this.ctAutor.Text = "David Fernndez";
        this.ctDescripcion.Text = "Fco. Javier Ceballos en su despacho de la Universidad";
      }
    }

    private string ObtenerUrlServicioWeb()
    {
      string sUrl = string.Empty;
      // Obtener la Url del servicio Web

      // Por ejemplo:
      sUrl = "http://www.fjceballos.es/";

      return sUrl;
    }

    private void btPrimero_Click(object sender, EventArgs e)
    {
      MessageBox.Show("Primera foto");
      // _iActual = 0 o a -1 si no hay fotos
      ActualizarFoto();
    }

    private void btAnterior_Click(object sender, EventArgs e)
    {
      MessageBox.Show("Foto anterior");
      // _iActual--;
      // Verificar que se trata de un valor vlido
      ActualizarFoto();
    }

    private void btSiguiente_Click(object sender, EventArgs e)
    {
      MessageBox.Show("Foto siguiente");
      // _iActual++;
      // Verificar que se trata de un valor vlido
      ActualizarFoto();
    }

    private void btUltimo_Click(object sender, EventArgs e)
    {
      MessageBox.Show("ltima foto");
      // _iActual = n_fotos-1 o a -1 si no hay fotos
      ActualizarFoto();
    }

    private void aadirFoto_Click(object sender, EventArgs e)
    {
      Aadir formAadir = new Aadir();
      if (formAadir.ShowDialog() == DialogResult.OK)
      {
        RecuperarBD();
        ActualizarFoto();
      }
    }

    private void eliminarFoto_Click(object sender, EventArgs e)
    {
      Eliminar formEliminar = new Eliminar();
      if (formEliminar.ShowDialog() == DialogResult.OK)
      {
        RecuperarBD();
        ActualizarFoto();
      }
    }
  }
}
