﻿using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

namespace ClienteDeEscritorioFotos
{
  public partial class Mostrar : Form
  {
    private int _iActual = -1; // índice de la foto mostrada

    public Mostrar()
    {
      InitializeComponent();
    }

    private void Mostrar_Load(object sender, EventArgs e)
    {
      RecuperarBD();
      ActualizarFoto();
    }

    private void RecuperarBD()
    {
      // Recuperar las fotos de la base de datos y almacenarlas
      // en un conjunto de datos

      // Actualizar el índice de la foto si hubiera sido afectado
      // por la operación eliminar foto.

      // Supongamos que hay una foto:
      _iActual = 0;
    }

    private void ActualizarFoto()
    {
      // Mostrar la foto especificada por _iActual
      // y la información sobre la misma
      string sUrl = GetUrlFotos();

      if (_iActual == -1)
      {
        this.ciFoto.Image = null;
        this.ctNombre.Text = string.Empty;
        this.ctAutor.Text = string.Empty;
        this.ctDescripcion.Text = string.Empty;
      }
      else
      {
        string rutaFoto = "imagenes/yo.png";
        this.ciFoto.Image = Image.FromStream(new System.Net.WebClient().OpenRead(sUrl + rutaFoto));
        //this.ciFoto.Image = Image.FromFile(RutaFotos + );

        this.ctNombre.Text = "Profesor Ceballos";
        this.ctAutor.Text = "David Fernández";
        this.ctDescripcion.Text = "Fco. Javier Ceballos en su despacho de la Universidad";
      }
    }

    private string GetUrlFotos()
    {
      string sUrl = string.Empty;
      // Obtener la Url donde del servicio Web

      // Por ejemplo:
      sUrl = "http://www.fjceballos.es/";

      return sUrl;
    }

    private void btPrimero_Click(object sender, EventArgs e)
    {
      MessageBox.Show("Primera foto");
      // _iActual = 0 o a -1 si no hay fotos
      ActualizarFoto();
    }

    private void btAnterior_Click(object sender, EventArgs e)
    {
      MessageBox.Show("Foto anterior");
      // _iActual--;
      // Verificar que se trata de un valor válido
      ActualizarFoto();
    }

    private void btSiguiente_Click(object sender, EventArgs e)
    {
      MessageBox.Show("Foto siguiente");
      // _iActual++;
      // Verificar que se trata de un valor válido
      ActualizarFoto();
    }

    private void btUltimo_Click(object sender, EventArgs e)
    {
      MessageBox.Show("Última foto");
      // _iActual = n_fotos-1 o a -1 si no hay fotos
      ActualizarFoto();
    }

    private void añadirFoto_Click(object sender, EventArgs e)
    {
      Añadir formAñadir = new Añadir();
      if (formAñadir.ShowDialog() == DialogResult.OK)
      {
        RecuperarBD();
        ActualizarFoto();
      }
    }

    private void eliminarFoto_Click(object sender, EventArgs e)
    {
      Eliminar formEliminar = new Eliminar();
      if (formEliminar.ShowDialog() == DialogResult.OK)
      {
        RecuperarBD();
        ActualizarFoto();
      }
    }
  }
}
