using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Controles
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

    private void btAñadir_Click(object obj, EventArgs ev)
    {
      if (ctDato.Text != "") lsLista.Items.Add(ctDato.Text);
    }
    
    private void cvCursiva_CheckedChanged(object obj, EventArgs ev)
    {
      if (cvCursiva.Checked) // si cvCursiva está marcada
        ctDato.Font = new Font("Microsoft Sans Serif", 8.25F,
                                FontStyle.Italic);
      else // si cvCursiva no está marcada
        ctDato.Font = new Font("Microsoft Sans Serif", 8.25F,
                                FontStyle.Regular);
    }
    
    private void boLecEsc_CheckedChanged(object obj, EventArgs ev)
    {
      if (boLectura.Checked) ctDato.ReadOnly = true;
      if (boEscritura.Checked) ctDato.ReadOnly = false;
    }

    private void bdhColorTexto_Scroll(object obj, ScrollEventArgs ev)
    {
      ctDato.ForeColor = Color.FromArgb(bdhColorTexto.Value,
                                        bdhColorTexto.Value,
                                        bdhColorTexto.Value);
    }

    private void lsLista_SelectedIndexChanged(object obj, EventArgs ev)
    {
      ctDato.Text = Convert.ToString(lsLista.SelectedItem);
    }

    private void itOpcionesColor_Click(object obj, EventArgs ev)
    {
      // Construir un diálogo de la clase ColorDialog
      ColorDialog dlgColor = new ColorDialog();
      // Prevenir al usuario de crear colores personalizados
      dlgColor.AllowFullOpen = false;
      // Establecer el color actual de la caja de texto como inicial
      dlgColor.Color = ctDato.BackColor;
      // Mostrar el diálogo Color
      if (dlgColor.ShowDialog() == DialogResult.OK)
        // Si se pulsó Aceptar, establecer el color de fondo de la
        // caja de texto
        ctDato.BackColor = dlgColor.Color;
    }

    private void itOpcionesSalir_Click(object obj, EventArgs ev)
    {
      Close();
    }

    private void itAyudaAcercaDe_Click(object obj, EventArgs ev)
    {
      MessageBox.Show("Aplicación Controles. Versión 1.0" +
                      Environment.NewLine +
                      "Copyright (c) Fco. Javier Ceballos, 2008",
                      "Acerca de Controles",
                      MessageBoxButtons.OK,
                      MessageBoxIcon.Information);
    }
  }
}
