﻿using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Collections.Generic;
using System.IO;
using Npgsql;

namespace ClienteDeEscritorioFotos
{
  public partial class Eliminar : Form
  {
    public Eliminar()
    {
      InitializeComponent();
      lbFotos.DisplayMember = "Key"; // propiedad para mostrar por la lista
      lbFotos.ValueMember = "Value"; // propiedad para el valor del elemento de la lista

      CargarDatos(); // cargar los datos en la lista
    }

    private void CargarDatos()
    {
      // Limpiar la lista
      lbFotos.Items.Clear();
      // Conexión
      NpgsqlConnection Conexion = new NpgsqlConnection(Mostrar.sConexion);
      // Orden SQL
      string sOrdenSQL = "select nombre, foto from album";
      NpgsqlCommand OrdenSQL = new NpgsqlCommand(sOrdenSQL, Conexion);
      // Abrir la conexión con la BD y ejecutar la orden SQL
      Conexion.Open();
      NpgsqlDataReader Lector = OrdenSQL.ExecuteReader();
      if (Lector != null)
      {
        while (Lector.Read())
        {
          lbFotos.Items.Add(new KeyValuePair<string, string>(
            Lector.GetString(0), Lector.GetString(1)));
        }
      }
      Conexion.Close();
    }

    protected void btBorrar_Click(object sender, EventArgs e)
    {
      if (this.lbFotos.SelectedIndex != -1)
      {
        // Ruta de la foto
        string sFoto = ((KeyValuePair<string, string>)
                        this.lbFotos.SelectedItem).Value;
        // Borrar el fichero que almacena la foto
        File.Delete(Mostrar.sRutaFotos + sFoto);
        // Borrar el registro correspondiente de la base de datos
        try
        {
          Eliminar_Foto(sFoto);
          lbFotos.Items.Remove(lbFotos.SelectedItem);
          this.Close();
        }
        catch
        {
          MessageBox.Show(this, "Error al borrar la foto: " + 
            sFoto, "Borrar foto",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
      }
    }

    public void Eliminar_Foto(string foto)
    {
      // Borrar el registro correspondiente a "foto" de la BD
      NpgsqlConnection Conexion = new NpgsqlConnection(Mostrar.sConexion);

      string sOrdenSQL = "delete from album where foto = :foto";

      NpgsqlCommand OrdenSQL = new NpgsqlCommand(sOrdenSQL, Conexion);
      OrdenSQL.Parameters.Add(new NpgsqlParameter("foto",
        NpgsqlTypes.NpgsqlDbType.Varchar, 30));
      OrdenSQL.Parameters["foto"].Value = foto;

      OrdenSQL.Connection.Open();
      OrdenSQL.ExecuteNonQuery();
      OrdenSQL.Connection.Close();
    }
  }
}
