using System;
using Npgsql;

namespace DataReader
{
  public class BaseDeDatos
  {
    private NpgsqlConnection ConexionConBD;
    private NpgsqlCommand OrdenSQL;
    private NpgsqlDataReader Lector;

    public void LeerDeBaseDeDatos()
    {
      // Crear el objeto conexión
      String strConexion = "SERVER=localhost;Database=fotos;" +
                           "User name=postgres;Password=abcde";
      ConexionConBD = new NpgsqlConnection(strConexion);
      // Crear una consulta
      String Consulta = "SELECT nombre, foto FROM album";
      OrdenSQL = new NpgsqlCommand(Consulta, ConexionConBD);

      // Abrir la base de datos
      ConexionConBD.Open();
      // ExecuteReader hace la consulta y devuelve un NpgsqlDataReader
      Lector = OrdenSQL.ExecuteReader();
      // Llamar siempre a Read antes de acceder a los datos
      while (Lector.Read()) // siguiente registro
      {
        Console.WriteLine(Lector.GetString(0) + ", " +
                          Lector.GetString(1));
      }
      // Llamar siempre a Close una vez finalizada la lectura
      Lector.Close(); Lector = null;
    }
    
    public void CerrarConexion()
    {
      // Cerrar la conexión cuando ya no sea necesaria
      if (Lector != null) Lector.Close();
      if (ConexionConBD != null) ConexionConBD.Close();
    }

    public static void Main()
    {
      BaseDeDatos bd = new BaseDeDatos();
      try
      {
        bd.LeerDeBaseDeDatos();
      }
      catch(Exception e)
      {
        Console.WriteLine("Error: " + e.Message);
      }
      finally
      {
        bd.CerrarConexion();
      }
    }
  }
}