using System;
using System.Data;
using Npgsql;

namespace DataSetAp
{
  public class BaseDeDatos
  {
    private NpgsqlConnection ConexionConBD = null;
    private NpgsqlDataAdapter adaptador = null;
    private DataSet ds = null;

    public void LeerDeBaseDeDatos()
    {
      // Crear el objeto conexión
      String strConexion = "SERVER=localhost;Database=fotos;" +
                           "User name=postgres;Password=abcde";
      ConexionConBD = new NpgsqlConnection(strConexion);
      // Crear una consulta
      String Consulta = "SELECT nombre, foto FROM album";

      // Crear el adaptador de datos
      adaptador = new NpgsqlDataAdapter(Consulta, ConexionConBD);
      // Crear el conjunto de datos
      ds = new DataSet("fotos");
      // Recuperar los datos del origen de datos mediante el SELECT
      // del adaptador y mostrar los resultados
      adaptador.Fill(ds);
      // Recorrer las filas de la tabla
      if (ds.Tables.Count == 0) return;
      for (int i = 0; i < ds.Tables[0].Rows.Count; ++i)
      {
        Console.WriteLine(
          ds.Tables[0].Rows[i]["foto"].ToString() + ", " +
          ds.Tables[0].Rows[i]["nombre"].ToString());
      }
    }
    
    public void CerrarConexion()
    {
      // Cerrar la conexión cuando ya no sea necesaria
      if (ConexionConBD != null) ConexionConBD.Close();
    }

    public static void Main()
    {
      BaseDeDatos bd = new BaseDeDatos();
      try
      {
        bd.LeerDeBaseDeDatos();
      }
      catch(Exception e)
      {
        Console.WriteLine("Error: " + e.Message);
      }
      finally
      {
        bd.CerrarConexion();
      }
    }
  }
}