// Añadir.aspx.cs created with MonoDevelop
//

using System;
using System.Web;
using System.Web.UI;
using System.IO;
using Npgsql;
using System.Configuration;

namespace ClienteWebFotos
{
	public partial class Agregar : System.Web.UI.Page
	{
	  protected void btAgregar_Click(object sender, EventArgs e)
	  {
	    if (FormularioCorrecto())
	    {
	      // Ruta de la carpeta "fotos" en el sitio web
	      string sRutaFotos = Server.MapPath("fotos");
	      // Subir el fichero al servidor
	      fuFichero.PostedFile.SaveAs(sRutaFotos +
                    Path.DirectorySeparatorChar +
                    fuFichero.FileName);
	      etMsjFichero.Text = " Archivo subido con éxito!!!";

	      // Guardamos la información en la base de datos
	      string sFoto = "fotos/" + fuFichero.FileName;
	      string sNombre = ctNombre.Text;
	      string sAutor = ctAutor.Text;
	      string sDescripcion = ctDescripcion.Text;
	      if (ctDescripcion.Text.Length == 0)
	        sDescripcion = "-- Sin Descripción --";

        Anadir_Foto(sFoto, sNombre, sAutor, sDescripcion);

	      Response.Redirect("Mostrar.aspx");
	    }
	  }

	  protected bool FormularioCorrecto()
	  {
	    bool bArchivoCorrecto = true;
	    bool bNombreCorrecto = true;
	    bool bAutorCorrecto = true;

	    // Volvemos a dejar en blanco los comentarios
	    etErrNombre.Text = "";
	    etErrAutor.Text = "";
	    etMsjFichero.Text = "";

	    // Comprobamos el formulario
	    if (fuFichero.FileName.Length == 0)
	    {
	      etMsjFichero.Text = "* Error: seleccione un archivo!!";
	      bArchivoCorrecto = false;
	    }
	    if (ctAutor.Text.Length == 0)
	    {
	      etErrAutor.Text = "* Error: debe introducir un autor";
	      bAutorCorrecto = false;
	    }
	    if (ctNombre.Text.Length == 0)
	    {
	      etErrNombre.Text = "* Error: debe introducir un nombre";
	      bNombreCorrecto = false;
	    }

	    return (bArchivoCorrecto && bNombreCorrecto && bAutorCorrecto);
	  }
    
    public void Anadir_Foto(string foto, string nombre,
                            string autor, string descripcion)
    {
      // Cadena de conexión (véase Web.Config)
      string sConexion = 
          ConfigurationManager.ConnectionStrings["cc_fotos"].ConnectionString;
      NpgsqlConnection Conexion = new NpgsqlConnection(sConexion);

      string sOrdenSQL =
        "insert into album (foto, nombre, autor, descripcion) " +
        "values (:foto,:nombre,:autor,:descripcion)";

      NpgsqlCommand OrdenSQL = new NpgsqlCommand(sOrdenSQL, Conexion);

      OrdenSQL.Parameters.Add(new NpgsqlParameter("foto",
        NpgsqlTypes.NpgsqlDbType.Varchar, 30));
      OrdenSQL.Parameters["foto"].Value = foto;

      OrdenSQL.Parameters.Add(new NpgsqlParameter("nombre",
        NpgsqlTypes.NpgsqlDbType.Varchar, 30));
      OrdenSQL.Parameters["nombre"].Value = nombre;

      OrdenSQL.Parameters.Add(new NpgsqlParameter("autor",
        NpgsqlTypes.NpgsqlDbType.Varchar, 30));
      OrdenSQL.Parameters["autor"].Value = autor;

      OrdenSQL.Parameters.Add(new NpgsqlParameter("descripcion",
        NpgsqlTypes.NpgsqlDbType.Varchar, 400));
      OrdenSQL.Parameters["descripcion"].Value = descripcion;

      OrdenSQL.Connection.Open();
      OrdenSQL.ExecuteNonQuery();
      OrdenSQL.Connection.Close();
    }
	}
}
