using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using Npgsql;

namespace FormWinNotas
{
  public partial class Form1 : Form
  {
    // Cadena de conexin con la base de datos
    public const string sConexion =
      "SERVER=localhost;Database=notas_alumnos;" +
      "User name=postgres;Password=abcde";
    // Servicio Web (proxy)
    private rServWebNotas.ServWebNotas servicio;

    public Form1()
    {
      InitializeComponent();
      etError.Text = null;

      servicio = new rServWebNotas.ServWebNotas();
      DataSet ds1 = servicio.ObtenerAsignaturas();
      lsdAsignatura.DataSource = ds1.Tables[0];
      lsdAsignatura.DisplayMember = "nombre"; // campo a mostrar en la lista
      lsdAsignatura.ValueMember = "id_asignatura"; // valor a almacenar en la lista
    }

    private void btConsultarNota_Click(object sender, EventArgs e)
    {
      if (FormularioCorrecto())
      {
        try
        {
          // Obtener el nombre y la nota
          DataSet ds2 = servicio.ObtenerNota(Convert.ToInt32(ctDni.Text),
            Convert.ToInt32(lsdAsignatura.SelectedValue));
          if (ds2.Tables[0].Rows.Count == 0)
          {
            etNombre.Text = etNota.Text = "";
            etError.Text = "Error: no est en acta";
            return;
          }
          // Mostrar el resultado en las etiquetas del formulario
          DataRow fila = ds2.Tables[0].Rows[0];
          etNombre.Text = Convert.ToString(fila["nombre"]);
          etNota.Text = Convert.ToSingle(fila["nota"]).ToString();
        }
        catch (Exception ex)
        {
          etError.Text = ex.Message;
        }
      }
    }

    protected bool FormularioCorrecto()
    {
      bool bDni = true;
      string mensajeError = null;
      long dni = 0;
      etError.Text = etNombre.Text = etNota.Text = null;

      // Comprobamos los datos del formulario
      if (ctDni.Text.Length == 0)
      {
        mensajeError = "DNI requerido";
        bDni = false;
      }
      else
      {
        try
        {
          dni = Convert.ToInt64(ctDni.Text);
          if (dni < 999999 || dni > 99999999)
          {
            mensajeError = "Valor fuera de rango";
            bDni = false;
          }
        }
        catch (Exception ex)
        {
          mensajeError = "DNI no valido";
          bDni = false;
        }
      }

      if (!bDni)
        etError.Text = mensajeError;
      return bDni;
    }
  }
}