// Default.aspx.cs created with MonoDevelop
// Autor: Fco. Javier Ceballos
//

using System;
using System.Web;
using System.Web.UI;
using System.Data;

namespace FormWebNotas
{
  public partial class Default : System.Web.UI.Page
  {
    private rServWebNotas.ServWebNotas servicio;

    protected void Page_Init(object sender, EventArgs e)
    {
      servicio = new rServWebNotas.ServWebNotas();
      DataSet ds1 = servicio.ObtenerAsignaturas();
      lsdAsignatura.DataSource = ds1.Tables[0];
      // Propiedades DataTextField y DataValueField establecidas
      // en el fichero .aspx
      lsdAsignatura.DataBind();
    }

    protected void Page_Load(object sender, EventArgs e)
    {
      etError.Text = "";
    }

    protected void  btConsultarNota_Click(object sender, EventArgs e)
    {
      try
      {
        DataSet ds2 = servicio.ObtenerNota(Convert.ToInt32(ctDni.Text), Convert.ToInt32(lsdAsignatura.SelectedItem.Value));
        if (ds2.Tables[0].Rows.Count == 0)
        {
          etNombre.Text = etNota.Text = "";
          etError.Text = "Error: no está en acta";
          return;
        }
        // Mostrar el resultado en las etiquetas del formulario
        DataRow fila = ds2.Tables[0].Rows[0];
        etNombre.Text = Convert.ToString(fila["nombre"]);
        etNota.Text = Convert.ToSingle(fila["nota"]).ToString();
      }
      catch (Exception ex)
      {
        etError.Text = ex.Message;
      }
    }
	}
}
